# Preview for Jumping Moves!!!

execfile('setup.txt')

if moveforwards:
	DIRECTION = 10
	ANTDIRECTION = 12
	CHECKDIR="""{MNAME}_ChkDirection:
	btst	#0,$22(a0)		; is sonic facing left?
	beq.s	{MNAME}_MovePlayer			; if yes, branch
	neg.w	d0			; if not, negate d0 (for jumping to the right)""".replace('{MNAME}', OURNEWMOVENAME)
elif moveright:
	DIRECTION = 10
	ANTDIRECTION = 12
	CHECKDIR="""{MNAME}_ChkDirection:
	neg.w	d0			; negate d0 (for jumping to the right)""".replace('{MNAME}', OURNEWMOVENAME)
elif moveleft:
	DIRECTION = 10
	ANTDIRECTION = 12
	CHECKDIR = ""
elif movedown:
	DIRECTION = 12
	ANTDIRECTION = 10
	CHECKDIR = ""
elif moveup:
	DIRECTION = 12
	ANTDIRECTION = 10
	CHECKDIR="""{MNAME}_ChkDirection:
	neg.w	d0			; negate d0 (for jumping down)""".replace('{MNAME}', OURNEWMOVENAME)
else:
	CHECKDIR="""{MNAME}_ChkDirection:
	neg.w	d0			; negate d0 (for jumping down)""".replace('{MNAME}', OURNEWMOVENAME)
	DIRECTION = 12
	ANTDIRECTION = 10
	
if sound:
	soundPlay = """move.w	#${SOUND},d0			; set sound
	jsr	(PlaySound).l		; play sound""".replace('{SOUND}', sound)
else:
	soundPlay = ""
		
if dotwice:
	TESTFLAGPROCEDURE = ''
	CLEARFLAGPROCEDURE = ''
	RESETFLAGPROCEDURE = ''
else:
	TESTFLAGPROCEDURE = """tst.b	($FFFFFFEB).w		; was the move flag set?
\tbne.w	{MNAME}_End			; if yes, branch
\tmove.b	#1,($FFFFFFEB).w	; if not, set move flag""".replace('{MNAME}', OURNEWMOVENAME)
	CLEARFLAGPROCEDURE = "bclr	#4,$22(a0)		; clear move flag"
	RESETFLAGPROCEDURE = "move.b	#0,($FFFFFFEB).w	; reset move flag"

takeRings = """cmpi.w	#{RINGS},(Ring_count).w	; does Sonic have at least {RINGS} rings?
	bcs.s	{MNAME}_End		; if not, branch
	subq.w	#{RINGS},(Ring_count).w ; Subtract {RINGS} rings.
	ori.b	#1,(Update_HUD_rings).w ; Update the HUD.""".replace('{RINGS}', `minusrings`).replace('{MNAME}', OURNEWMOVENAME)

d = {}

d['{{{ROUTINECALL}}}'] = "bsr.w "+OURNEWMOVENAME

d['{{{RESETMOVEFLAG}}}'] = RESETFLAGPROCEDURE

theProcedure = """
; ---------------------------------------------------------------------------
; Subroutine to perform a NEW move!!!!!!!!
; ---------------------------------------------------------------------------

{MNAME}:
	move.b	($FFFFF603).w,d0	; Get keys pressed...
	andi.b	#$70,d0	; check if A, B, or C is pressed...
	beq.w	{MNAME}_End	; If not, branch
	{TESTFLAG}
	{SOUNDPLAY}
	{TAKERINGS}
	{CLEARFLAG}
	move.w	#${SPEED},d0	; set the speed to d0

{CHECKDIR}

{MNAME}_MovePlayer:
	move.w	d0,${DIRECTION}(a0)	; Move Sonic...
	{CLEAROTHER}

{MNAME}_End:
	rts				; return
; End of function {MNAME}"""

theProcedure = theProcedure.replace('{MNAME}', OURNEWMOVENAME)

theProcedure = theProcedure.replace('{TESTFLAG}', TESTFLAGPROCEDURE)

theProcedure = theProcedure.replace('{CLEARFLAG}', CLEARFLAGPROCEDURE)

theProcedure = theProcedure.replace('{SOUNDPLAY}', soundPlay)

theProcedure = theProcedure.replace('{TAKERINGS}', takeRings)

theProcedure = theProcedure.replace('{SPEED}', `moveSpeed`)

theProcedure = theProcedure.replace('{CHECKDIR}', CHECKDIR)

theProcedure = theProcedure.replace('{DIRECTION}', `DIRECTION`)

co = """clr.w	${ANTDIRECTION}(a0)	; Stop Sonic's velocity in the other direction...""".replace('{ANTDIRECTION}', `ANTDIRECTION`)
if not clearOther: co = ''

theProcedure = theProcedure.replace('{CLEAROTHER}', co)

d['{{{OURNEWMOVE}}}'] = theProcedure
print theProcedure
def makeASM(filename, reset=False):
	if reset:
		for i in d.keys():
			d[i] = ''
			
	try: x = open('backup_'+filename, 'r')
	except: x = open(filename, 'r')
	wds = x.read()
	x.close()
	
	y = open('backup_'+filename, 'w')
	y.write(wds)
	y.close()
	
	for x in d.keys():
		wds = wds.replace(x, d[x])
		
	z = open(filename, 'w')
	z.write(wds)
	z.close()

makeASM('s2.asm')